import unit4.collectionsLib.BinTree;
import unit4.utilsLib.BinTreeUtils;

public class TreeDiameter
{
	public static void main(String[] args) 
	{
		//int[] pre = {1,5,7,3,8,4,6,1};
		//int[] in  = {7,5,8,3,1,4,6,1};
		//BinTreeUtils.showTree(reconstruct(pre,in), "tree");
		
		BinTree<Integer> t1 = BinTreeUtils.buildRandomTree(3, 1, 30);
		BinTreeUtils.showTree(t1,"t1");
		System.out.println(diameter(t1));
	}
	
	public static BinTree reconstructBinTree(int[] preorder, int[] inorder)
	{
		BinTree t = new BinTree(preorder[0]);
		int i = 0;
		//           
		while (preorder[0] != inorder[i])
			i++;
		//  
		if (i > 0)
		{
			int[] preorderL = new int [i];
			int[] inorderL = new int[i];
			for (int j=0; j<i; j++)
			{
				preorderL[j] = preorder[j+1]; 
				inorderL[j] = inorder[j];
			}
			t.setLeft(reconstructBinTree(preorderL,inorderL));
		}
		//  
		if (i < inorder.length-1)
		{
			int[] preorderR = new int [inorder.length-1-i];
			int[] inorderR = new int[inorder.length-1-i];
			for (int j=i+1; j<inorder.length; j++)
			{
				preorderR[j-i-1] = preorder[j]; 
				inorderR[j-i-1] = inorder[j];
			}
			t.setRight(reconstructBinTree(preorderR,inorderR));
		}
		return t;				
	}

	
	public static BinTree reconstruct(int[] preorder, int[] inorder)
	{	
		print(preorder,inorder);
		if(preorder.length==1)
		   return(new BinTree(preorder[0]));
		
		int i=0;
		while (preorder[0] != inorder[i])
			i++;
		
		int[] preorderL = new int [i];
		int[] inorderL = new int[i];
		for (int j=0; j<i; j++)
		{
			preorderL[j] = preorder[j+1]; 
			inorderL[j] = inorder[j];
		}
		//print(preorderL,inorderL);
		int[] preorderR = new int [inorder.length-i-1];
		int[] inorderR = new int[inorder.length-i-1];
		for (int j=i+1; j<inorder.length; j++)
		{
			preorderR[j-i-1] = preorder[j]; 
			inorderR[j-i-1] = inorder[j];
		}
		//print(preorderR,inorderR);
		return(new BinTree(preorder[0],reconstruct(preorderL,inorderL),reconstruct(preorderR, inorderR)));	
	}
	
	public static void print(int[] a, int[] b)
	{
		for (int i = 0; i < a.length; i++) 
		{
			System.err.print(a[i]+" ");
		}
		System.err.println();
		for (int i = 0; i < b.length; i++) 
		{
			System.err.print(b[i]+" ");
		}
		System.err.println();
		System.err.println();
	}
	
	public static int diameter(BinTree<Integer> bt)
	{
		int treeDiameter = 1;	//      1
		int h = height(bt);		//   
		
		//     ,        
		for(int level=1; level<=h; level++)
		{
			int n = numNodesInLevel(bt,level); //    
			if(n>treeDiameter)
				treeDiameter = n;
		}

		return treeDiameter;
	} 

	public static int numNodesInLevel(BinTree<Integer> tree, int level)
    {
    	int sl = 0;
    	int sr = 0;
    	
    	if(level==0)
    		return(1);
    	if(tree.getLeft() != null)
    		sl = numNodesInLevel(tree.getLeft(),level-1);
    	if(tree.getRight() != null)
    		sr = numNodesInLevel(tree.getRight(),level-1);
    	return(sl + sr);
    }  
	
	public static int height(BinTree<?> tree)
    {
    	int hl = 0;
    	int hr = 0;
    	
    	if(tree.getLeft() != null)
    		hl = 1 + height(tree.getLeft());
    	if(tree.getRight() != null)
    		hr = 1 + height(tree.getRight());
    	return(Math.max(hl,hr));
    }    
}

